# Oct 2010, kyyu
# version 0.3b
# description:  This plugin groups and pushpull all 2D faces selected. 
#                   * You can manually change these 3 default setting, at the beginning of the code.
#               -Default Thickness: change the value "thickness_default ="
#               -If you don't want an input box, change to "use_input_box = false".
#               -If you want components instead of groups, change to "default_use_component = true".
#
# v0.3b fixed bug
# v0.3  added component option
# v0.2  added input box
# v0.1  original

require 'sketchup.rb'

def kyyu_group_pushpull_2D_faces
    #### Change these default values manually ####
    thickness_default = 0.25
    use_input_box = true
    default_use_component = false
    ####                                      ####
    
    if use_input_box
        prompts = ["Thickness", "Make Components "]
        defaults = [thickness_default.to_s, default_use_component.inspect()]
        list = ["","false|true"]
        input = UI.inputbox prompts, defaults, list, "Push/Pull Thickness"
        ppthick = Sketchup.parse_length(input[0]).to_f
        use_component = (input[1] == 'true')        
    else 
        ppthick = thickness_default
        use_component = default_use_component        
    end
    #puts ppthick
    
    model = Sketchup.active_model
	ent = model.entities
	sel = model.selection
    faces = []
		
	sel.each do |e|
		if e.is_a? Sketchup::Face
            faces.push e
		end
	end   

    Sketchup.active_model.start_operation "Group PushPull 2D Faces"     
	faces.each do |e|
        g = ent.add_group e
        e.pushpull (-ppthick)
        if use_component then c = g.to_component end
    end
			Sketchup.active_model.commit_operation	
end


if( not file_loaded?('ky_Group_PushPull_2DFaces.rb') )
UI.menu('Plugins').add_item('[ky] Group and PushPull 2D Faces') { kyyu_group_pushpull_2D_faces }
end

file_loaded 'ky_Group_PushPull_2DFaces.rb'


